
package de.ivu.elect.presentation.wahlvorschlag.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlvorschlag.boundary.ListenverbindungConversationSelect;
import de.ivu.elect.business.wahlvorschlag.entity.Liste;
import de.ivu.elect.business.wahlvorschlag.entity.Listenverbindung;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.wahlvorschlag.ListenverbindungEditView;

@Named(ListeListenverbindungEditAction.COMPONENT_NAME)
public class ListeListenverbindungEditAction extends AbstractListeAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "listeListenverbindungEditAction";

  @Inject
  private transient ListenverbindungConversationSelect listenverbindungSelect;

  public ListeListenverbindungEditAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.LISTENVERBINDUNG_EDIT;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Liste liste) {
    return super.isDisabledInternal(liste) || liste.getListenverbindung() == null;
  }

  @Override
  protected String doIt(Liste liste) {
    Listenverbindung listenverbindung = attach(liste).getListenverbindung();

    if (listenverbindung == null) {
      messages.addErrorMessage("liste.edit.action.listenverbindung.edit.error.keine.listenverbindung");

      return null;
    }

    listenverbindungSelect.setEntity(listenverbindung);

    return ListenverbindungEditView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "liste.edit.action.listenverbindung.edit";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconEdit();
  }
}
